/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-*/
/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is Urban Rage Software code.
The Initial Developer of the Original Code is Eric Plaster.

Portions created by Urban Rage Software are
Copyright (C) 2001 Urban Rage Software.  All
Rights Reserved.

Contributor(s): Eric Plaster <plaster@urbanrage.com)> (original author)
                Michael Bensch (modifications for BCImoz)
*/
/* Modifications
 * 15.1.: throwing out stuff we do not strictly need for BCI
 */



var gOptions = null;
var gButtonList = null;
var mIntervalID;
var gEntryPoint = "window.opener.manager";

ddd = function (str) {dump ("---dlg: " + str + "\n");}
//ddd = function (){};

function onLoad()
{
  window.opener.manager.mMsgWinEvents == true; //always default to true
  if(window.arguments && window.arguments[0])
  {
    //ddd("cdialog::onLoad()");
    var mLen = window.arguments.length;
    //ddd("winargs length: " + mLen);
    //ddd(window.arguments);
    if (mLen > 1) {
      ddd("window opened from cpp!!!")
	for (var i=0; i< mLen; i++) {
	  ddd("eval: " + window.arguments[i] + "");
	  eval(window.arguments[i]);
	}
    } else {
      ddd("setting gOptions");
      gOptions = window.arguments[0];
    }

    if (gOptions.timer > 0) { 
      // pause BCI. Continue when window closes
      window.opener.manager.pauseBCI = "red"; 
    } else { // hide countdown textbox
      document.getElementById("textboxCounter").hidden = "true";
    }
    setupImage();
    setupMessage();
    if (gOptions.buttonList) {
      setupButtons();
    }
    if ((gOptions.timer) && (gOptions.timer > 0)) {
      starten();
    }
    if (gOptions.title) {
      setTimeout("setupTitle();", 10);
    }
    if (gOptions.closeCondition) {
      ddd("setting interval for close condition...");
      mIntervalID = setInterval("checkCondition()",1000);
    }
    //Why does this not work??? Try this from XUL!!! or with timeout???
    //window.sizeToContent();
    //ddd("sizeToContent");
    if (window.opener.gPref.autoSizeWindow) {
      // get screen dimensions
      var scrWidth = window.screen.availWidth;
      var scrHeight = window.screen.availHeight;
      var scrTop = window.screen.availTop;

      // get browser window dimensions
      var brwX = window.opener.window.screenX;

      // get this window's dimensions
      var width = window.outerWidth;
      var height = window.outerHeight;

      window.moveTo(0, scrTop);
      window.resizeTo(brwX, scrHeight);
      ddd(scrWidth);
      ddd(brwX);
    }
  }
}

function checkCondition() {
  var cond;
  try {
    cond = eval(gOptions.closeCondition);
  } catch (ex) {
    ddd("Probably closed main window and now the parent is missing...");
    ddd("ex: " + ex);
    clearInterval(mIntervalID); //stop regular checking of the condition
    window.close(); //this will call |onClose()|
  }
  if (cond == true) {
    clearInterval(mIntervalID); //stop regular checking of the condition
    window.removeEventListener("unload", onClose(), false);
    window.close(); //this will call |onClose()|
  }
}

function onClose() {
  //calling manager from here is not modular! try to get rid of this...
  //this is a real bug!!! window.opener seems to be gone
  //this is not reached from the "restart" mechanism
 
  //shouldn't we always set to green, irrespective of mMsgWinEvents?
  //29.5. moved this line up here.
  window.opener.manager.pauseBCI = "green"; 

  if (window.opener.manager.mMsgWinEvents == true) {
      if (gOptions.timer > 0) { //was a timer set?
        //see "displayUserMessage": BCI pauses when window opens, now restart
        //shouldn't we always set to green, irrespective of mMsgWinEvents?
        //window.opener.manager.pauseBCI = "green"; 
      }
      window.opener.menuRedraw(50);
      eval(gEntryPoint+".mMsgWinEvents = true;");
      window.opener.manager.msgWin = null; //query this later to see whether a window is open
      switch (gOptions.buttonHitText) {
      case "OK":
      case "Yes":
        ddd("eventYes!");
        if (gOptions.eventYes)
          eval("window.opener."+gOptions.eventYes);
        else 
          if (gOptions.eventDefault)
            eval("window.opener."+gOptions.eventDefault);
        break;
      case "Cancel": 
      case "No":
        ddd("eventNo!");
        if (gOptions.eventNo)
          eval("window.opener."+gOptions.eventNo);
        else         
          if (gOptions.eventDefault)
            eval("window.opener."+gOptions.eventDefault);
        break;
      case "timerElapsed":
        ddd("timerElapsed");
        if (gOptions.eventTimerClose)
          eval("window.opener."+gOptions.eventTimerClose);
        else if (gOptions.eventDefault) {
          var str = "window.opener."+gOptions.eventDefault;
          ddd("eval: " + str + "");
          eval(str);
        }
        break;
      case "_none_": //supervisor pressed <ESC>, default action
        ddd("ESC pressed.");
      default: 
        ddd("Evaluating default event.");
        if (gOptions.eventDefault)
          eval("window.opener."+gOptions.eventDefault);
      }
  } //if mMsgWinEvents is true
  else { 
    eval(gEntryPoint+".mMsgWinEvents = true;");
    ddd("NOT evaluating any events.");
  }
}

//----------------------------------------------------------------------
//Timer added by Michael Bensch, from JavaScript book by Stefan Koch
var secsLeft;
var trials;
var running = false;
var meinTimer;
var conn;

function starten() {
  if (running) {
    clearTimeout(meinTimer); //don't ask, just clear timer if it's running
  }
  running = true;
  secsLeft = gOptions.timer;

  /*  conn = window.opener.manager.sock;
  trials = Math.ceil(secsLeft*1000 / (conn.streamListener.trialLength + 1));
  secsLeft = Math.ceil(trials * conn.streamListener.trialLength / 1000);
  if ((secsLeft < 0) || (secsLeft > 600)) //in case something goes wrong
    secsLeft = gOptions.timer;
  window.status = "setting secleft to: " + secsLeft;
  */

  var minuten = Math.floor(secsLeft / 60); //Minuten
  var sekunden = secsLeft % 60;
  var str = "";
  if (sekunden < 10) {
    str = "" + minuten + ":0" + sekunden;
  } else {
    str = "" + minuten + ":" + sekunden;
  }
  var place = document.getElementById("textboxCounter");
  place.value = str;
  meinTimer = setTimeout("countdown()", 1000);
}

function countdown() {
  secsLeft--; //eine Sekunde runterzhlen
  var sekunden = secsLeft % 60;
  var minuten = Math.floor(secsLeft / 60);
 var str = "";
  if (sekunden < 10) {
    str = "" + minuten + ":0" + sekunden;
  } else {
    str = "" + minuten + ":" + sekunden;
  }
  var place = document.getElementById("textboxCounter");
  place.value = str;
  if ((secsLeft < 2) && (gOptions.position != "info")) {
    ddd(str+"-");
    place.setAttribute("style", "color:red;");
    meinTimer = setTimeout("finalcountdown()", 1000);
  } else if (secsLeft < 2) {
    running = false;
    gOptions.buttonHitText = "timerElapsed"; //not strictly a button...
    window.close();
  } else {
    meinTimer = setTimeout("countdown()",1000);
  }
}

var msLeft;

//we are now 4 seconds or lower till next trial (estimated)
function finalcountdown() {
  conn = window.opener.manager.sock;
  
  msLeft = conn.msBeforeTrial;
  //ddd("msLeft: " + msLeft);
  secsLeft = Math.round(msLeft / 1000);
  str = "0:0" + secsLeft;
  var place = document.getElementById("textboxCounter");
  place.value = str;
  //ddd(msLeft + "-");
  place.setAttribute("style", "color:red;");
  //put this in a pref
  if (conn.msAfterTrial < 300) { // a trial just finished
    running = false;
    gOptions.buttonHitText = "timerElapsed"; //not strictly a button...
    window.close();
  } else {
    meinTimer = setTimeout("finalcountdown()", 100); //check every 100 ms
  }
}


//----------------------------------------------------------------------
function setupImage()
{
  // setup the image...
  if(gOptions.type) {
    var imagebox = document.getElementById("imageBox");
    var image = document.createElement("image");
    if(gOptions.type == "message") {
      image.setAttribute("class", "message-icon");
    }
    else if(gOptions.type == "alert") {
      image.setAttribute("class", "alert-icon");
    }
    else if(gOptions.type == "error") {
      image.setAttribute("class", "error-icon");
    }
    else if(gOptions.type == "question") {
      image.setAttribute("class", "question-icon");
    }
    imagebox.appendChild(image);
  }

  if (gOptions.pic) {
    var imagebox2 = document.getElementById("imageBox2");
    var image2 = document.createElement("image");

    ddd("setupImage: other filename chosen: " + gOptions.pic);
    ddd(imagebox2);
    ddd(image2);
    image2.setAttribute("src", gOptions.pic);
    //image2.setAttribute("class", "question-icon");
    imagebox2.appendChild(image2);
    //ddd(imagebox2.innerHTML);
  }

}

function setupMessage()
{
  if(gOptions.message) {
    // for text wrapping, we have to append a child object
    document.getElementById("messageText").
      appendChild(document.createTextNode(gOptions.message));
  }
}

//if we have buttons, we should allow a choice from the BCI
function setupButtons()
{
  var align = "center";
  var bbox = document.getElementById("buttonBox");

  gButtonList = new Array;
  ddd("setupButtons");
  // if buttontype was specified, create button list from that.
  // otherwise use the manually specified button list.
  if(gOptions.buttontype) {
    if(gOptions.buttontype == "okcancel") {
      gButtonList[0] = "OK";
      gButtonList[1] = "Cancel";
    } else if(gOptions.buttontype == "yesno") {
      gButtonList[0] = "Yes";
      gButtonList[1] = "No";
    }
  } else {
    gButtonList = gOptions.buttonList;
  }
  //default is the last button in the list
  if(!gOptions.defaultButton) {
    gOptions.defaultButton = gButtonList.length -1;
  }
  if(gOptions.buttonalign) {
    align = gOptions.buttonalign;
  }
  // left spring
  var lspring = document.createElement("spacer");
  if(align == "left") {
    lspring.setAttribute("style", "width: 10px;");
  } else {
    lspring.setAttribute("flex", "1");
  }
  bbox.appendChild(lspring);

  // buttons...
  for(i=0; i<gButtonList.length; i++) {
    var button = document.createElement("button");
    button.setAttribute("label", gButtonList[i]);
    button.setAttribute("style", "left-margin: 5px; right-margin:5px;");
    button.setAttribute("oncommand", "doButton("+i+");");
    button.setAttribute("bnum", i);
    button.setAttribute("id", "bID"+i);
    if(i == gOptions.defaultButton) {
      button.setAttribute("default", "true");
    }
    bbox.appendChild(button);
  }

  // right spring
  var rspring = document.createElement("spacer");
  if(align == "right") {
    rspring.setAttribute("style", "width: 10px;");
  } else {
    rspring.setAttribute("flex", "1");
  }
  bbox.appendChild(rspring);

  var button = document.getElementById("bID"+gOptions.defaultButton);
  if(button) {
    button.focus();
  }
}

//---------------------------------------------------------------------------
function setupTitle() {
  //ddd("setupTitle");
  window.title = gOptions.title;
}

function doButton(which) {
  ddd("dobutton: " + which);
  var button = document.getElementById("bID"+which);
  if(button) {
    gOptions.buttonHitText = button.getAttribute("label");
    gOptions.buttonHit = button.getAttribute("bnum");
    ddd("gOptions.buttonHitText: " + gOptions.buttonHitText);
    ddd("gOptions.buttonHit: " + gOptions.buttonHit);
    window.close();
  }
}

function doEnter() {
  var button = document.getElementById("bID"+gOptions.defaultButton);
  if (button) {
    gOptions.buttonHitText = button.getAttribute("label");
    gOptions.buttonHit = button.getAttribute("bnum");
  } else { // no buttons displayed but supervisor pressed <Enter>
    gOptions.buttonHitText = "Yes";
  }
  window.close();
}

function doEsc() {
  gOptions.buttonHit = "_none_"; // same action as closing with <Alt>-F4
  window.close();
}

function DumpDOM(node)
{
	dump("--------------------- DumpDOM ---------------------\n");
	
	DumpNodeAndChildren(node, "");
	
	dump("------------------- End DumpDOM -------------------\n");
}


// This function does the work of DumpDOM by recursively calling itself to explore the tree
function DumpNodeAndChildren(node, prefix)
{
	dump(prefix + "<" + node.nodeName);

	var attributes = node.attributes;
	
	if ( attributes && attributes.length )
	{
		var item, name, value;
		
		for ( var index = 0; index < attributes.length; index++ )
		{
			item = attributes.item(index);
			name = item.nodeName;
			value = item.nodeValue;
			
			if ( (name == 'lazycontent' && value == 'true') ||
				 (name == 'xulcontentsgenerated' && value == 'true') ||
				 (name == 'id') ||
				 (name == 'instanceOf') )
			{
				// ignore these
			}
			else
			{
				dump(" " + name + "=\"" + value + "\"");
			}
		}
	}
	
	if ( node.nodeType == 1 )
	{
		// id
		var text = node.getAttribute('id');
		if ( text && text[0] != '$' )
			dump(" id=\"" + text + "\"");
	}
	
	if ( node.nodeName == "#text" )
		dump(" = \"" + node.data + "\"");
	
	dump(">\n");
	
	// dump IFRAME && FRAME DOM
	if ( node.nodeName == "IFRAME" || node.nodeName == "FRAME" )
	{
		if ( node.name )
		{
			var wind = top.frames[node.name];
			if ( wind && wind.document && wind.document.documentElement )
			{
				dump(prefix + "----------- " + node.nodeName + " -----------\n");
				DumpNodeAndChildren(wind.document.documentElement, prefix + "  ");
				dump(prefix + "--------- End " + node.nodeName + " ---------\n");
			}
		}
	}
	// children of nodes (other than frames)
	else if ( node.childNodes )
	{
		for ( var child = 0; child < node.childNodes.length; child++ )
			DumpNodeAndChildren(node.childNodes[child], prefix + "  ");
	} 
}
