/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-*/
/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is Nessi.
The Initial Developer of the Original Code is Michael Bensch.

Portions created by Michael Bensch are
Copyright (C) 2003.  All Rights Reserved.

Contributor(s): Michael Bensch 
*/



ddp = function (str) {dump ("---puz: " + str + "\n");}
//ddp = function (){};

var gPic = new Array();
var gPicState = new Array();
var gPicPrefix = "";
var gCover;
var gCount; // number of slices of the picture

var gTime1 = new Date();

function loadGame(aIdPrefix, aCount)
{
  ddp("loadGame()");
  gCount = aCount;

  // set picture slices to the back level
  var i;
  var str = "";
  gPicPrefix = aIdPrefix + "_0";
  ddp("gPicPrefix: " + gPicPrefix);
  
  for (i=1; i <= aCount; i++) {
  var tt = "slice" + i;
  ddp(tt);
    gPic[i] = document.getElementById(tt);
    ddp("sl: " + gPic[i]); 
    off(i);
  }

  // we have a window and a document!
  ddp("window: " + window);
  ddp("document: " + document);

  
}

function swop(aIndex)
{
  ddp("index: " + aIndex);
  var val;
  if (gPicState[aIndex]) {
    off(aIndex);
  } else {
    on(aIndex);
  }
  
}

function on(pos)
{
  gPicState[pos] = 1;
  gPic[pos].setAttribute("src", "resource:/res/bci/games/Bilder/"
                         + gPicPrefix + pos + ".jpg");
  checkReward();
}

function off(pos)
{
  gPicState[pos] = 0;
  gPic[pos].setAttribute("src", "resource:/res/bci/games/black4.gif");
}


function checkReward() 
{
  var i;
  var rew = true;
  for (i=1; i <= gCount; i++) {
    if (gPicState[i] == 0)
      rew = false;
  }
  if (rew) {
    var gTime2 = new Date();
    ddp("Puzzle time " + formatDateOffset((gTime2-gTime1)/1000, "%h:%m"));
    ddp("REWARD");
    document.getElementById("task").style.visibility = "hidden";
    var aus = document.getElementById("reinforcement");
    ddp("aus: " + aus);
    var te;
    switch (gPicPrefix) {
    case "bild0_0": te = document.createTextNode("Farmland bei Wepener, Free State (Sdafrika)");
      break;
    case "bild1_0": te =  document.createTextNode("Springbok - ein nationales Emblem in Sdafrika (Kalahari Gemsbok Nationalpark)");
      break;
    case "bild2_0": te = document.createTextNode("Loerie (Tauraco corythaix) im Kstenwald bei Knysna (Sdafrika)");
      break;
    case "bild3_0": te = document.createTextNode("Landschaft bei Clarens, Free State (Sdafrika)");
      break;
    case "bild4_0": te = document.createTextNode("Nashorn (Ceratotherium simum) im Hluhluwe Wildpark, Natal (Sdafrika)");
      break;
    case "bild5_0": te = document.createTextNode("Gemsbkke (Oryx gazella) sind hauptschlich Grasfresser. Kalahari-Gemsbok Nationalpark (Sdafrika)");
      break;
    default: te = document.createTextNode("Bildinformationen unbekannt.");
    }
    aus.appendChild(te);
    aus.style.visibility = "visible";

  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
  var a = Components.classes["@mozilla.org/observer-service;1"].getService();
  a = a.QueryInterface(Components.interfaces.nsIObserverService);
  ddp("a: " + a);
  a.notifyObservers(null,"pause",null);

  }
}


/* the offset should be in seconds, it will be rounded to 2 decimal places */
function formatDateOffset (seconds, format)
{
    seconds = parseInt(seconds);
    var minutes = parseInt(seconds / 60);
    seconds = seconds % 60;
    var hours   = parseInt(minutes / 60);
    minutes = minutes % 60;
    var days    = parseInt(hours / 24);
    hours = hours % 24;

    if (!format)
    {
        var ary = new Array();
        if (days > 0)
            ary.push (days + " days");
        if (hours > 0)
            ary.push (hours + " hours");
        if (minutes > 0)
            ary.push (minutes + " minutes");
        if (seconds > 0)
            ary.push (seconds + " seconds");

        format = ary.join(", ");
    }
    else
    {
        format = format.replace ("%d", days);
        format = format.replace ("%h", hours);
        format = format.replace ("%m", minutes);
        format = format.replace ("%s", seconds);
    } 
    return format;
}
